Description

In [Feature #14145],

https://bugs.ruby-lang.org/issues/14145#note-25

I think (a space) is better, and it's what we use for Method#inspect in TruffleRuby.

My motivation is that selection by double-clicking in the terminal just works with a space,

but fails with @ and results in 0x00007f850b8f9458@-e when double-clicking on the filename (-e here).

I find it also easier to read.

 I tried to introduce this change (@ ->  ).

Compatibility issue

Some code may be dependent on this string format. In fact, rubygems requires this patch:

diff --git a/lib/rubygems/installer.rb b/lib/rubygems/installer.rb

index b230ce7bed..554cfc4509 100644

--- a/lib/rubygems/installer.rb

+++ b/lib/rubygems/installer.rb

@@ -370,7 +370,7 @@ def run_post_build_hooks # :nodoc:

       if hook.call(self) == false

         FileUtils.rm_rf gem_dir

-        location = " at #{$1}" if hook.inspect =~ /@(.*:\d+)/

+        location = " at #{$1}" if hook.inspect =~ / (.*:\d+)/

         message = "post-build hook#{location} failed for #{spec.full_name}"

         raise Gem::InstallError, message

 I think we shouldn't use this string, but use source_location method.

I'll commit. If you have an issue, please re-open it.

Related issues:

Related to Ruby - Feature #14145: Proposal: Better Method#inspect Closed

Related to Ruby - Feature #16412: Thread#to_s to return "... file:line" inste... Closed

Associated revisions

Revision 182a408c2c4113eb316c2a87e35880144afb4498 - 08/14/2019 07:25 AM - ko1 (Koichi Sasada)

change Proc#to_s format ('@...' -> ' ...') (#2362)

Now Proc#to_s returns

"#Proc:0x00000237a0f5f170@t.rb:1".

However, it is convenient to select a file name by (double-)clicking

on some terminals by separating ' ' instead of '@' like

"#<Proc:0x00000237a0f5f170 t.rb:1>"

[Feature #16101]

Revision 182a408c2c4113eb316c2a87e35880144afb4498 - 08/14/2019 07:25 AM - ko1 (Koichi Sasada)

change Proc#to_s format ('@...' -> ' ...') (#2362)

Now Proc#to_s returns
"#Proc:0x00000237a0f5f170@t.rb:1".

However, it is convenient to select a file name by (double-)clicking

on some terminals by separating ' ' instead of '@' like

"#<Proc:0x00000237a0f5f170 t.rb:1>"

[Feature #16101]

Revision 182a408c - 08/14/2019 07:25 AM - ko1 (Koichi Sasada)

change Proc#to_s format ('@...' -> ' ...') (#2362)

Now Proc#to_s returns

"#Proc:0x00000237a0f5f170@t.rb:1".

However, it is convenient to select a file name by (double-)clicking

on some terminals by separating ' ' instead of '@' like

"#<Proc:0x00000237a0f5f170 t.rb:1>"

[Feature #16101]

History

#1 - 08/14/2019 06:59 AM - ko1 (Koichi Sasada)

- Related to Feature #14145: Proposal: Better Method#inspect added

#2 - 08/14/2019 07:25 AM - ko1 (Koichi Sasada)

- Status changed from Open to Closed

Applied in changeset git|182a408c2c4113eb316c2a87e35880144afb4498.

change Proc#to_s format ('@...' -> ' ...') (#2362)

Now Proc#to_s returns

"#Proc:0x00000237a0f5f170@t.rb:1".

However, it is convenient to select a file name by (double-)clicking

on some terminals by separating ' ' instead of '@' like

"#<Proc:0x00000237a0f5f170 t.rb:1>"

[Feature #16101]

#3 - 08/14/2019 02:14 PM - hsbt (Hiroshi SHIBATA)

- Status changed from Closed to Assigned

This change broke the minitest.

https://github.com/ruby/ruby/pull/2365/checks?check_run_id=193322770#step:10:168

#4 - 11/20/2019 10:17 AM - znz (Kazuhiro NISHIYAMA)

- Status changed from Assigned to Closed

https://github.com/seattlerb/minitest/pull/798 is closed.

#5 - 12/10/2019 12:59 AM - znz (Kazuhiro NISHIYAMA)

- Related to Feature #16412: Thread#to_s to return "... file:line" instead of "...@file:line" added

#6 - 08/05/2020 09:50 AM - sawa (Tsuyoshi Sawada)

- Description updated
